      subroutine wrntdcls(nu,var)
c----------------------------------------------------------------------c
c Writes declaration 'decl' of varible 'var' into a file associated with 
c an opened unit 'nu' in a fixed Fortran format, with maximum No of 
c continuation lines of 'mxncnt'
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 18-19 March, 2010; modified 5 Oct. 2010
c----------------------------------------------------------------------c

      use maxvals
      use declends

      implicit none

      integer :: nu
      character(80) :: var

      integer, parameter :: lcon=6,lline=72
      character(80), parameter :: decl=
     &                            '      integer, parameter :: '
      character(lcon), parameter :: con='     &' 
      integer :: ifrst=1,icon=0,icon0=0,ldecl,lvar,lclx
      character(80) :: clx,rest=''

      save ifrst,icon,clx,lclx,ldecl,icon0,rest

      lvar=len_trim(var)+1

      if (ifrst == 1) then
       clx=trim(decl)//trim(rest)
       ldecl=len_trim(decl)
       lclx=len_trim(clx)
       if (lclx+lvar > lline) then
        write(nu,'(a)') trim(clx)
        icon=icon+1
        clx=con//','//trim(var)
       else
        if (lclx > ldecl) then
         clx=trim(clx)//','//trim(var)
        else
c         clx=trim(clx)//' '//trim(var)
         clx=trim(clx)//trim(var)
        end if
       end if
       lclx=len_trim(clx)
       ntnend=trim(clx)
       ifrst=0
      else
       if (lclx+lvar > lline) then
        write(nu,'(a)') trim(clx)
        if ((icon+1)/mxncnt == icon0+1) then
         icon0=icon0+1
         ifrst=1
         rest=' '//trim(var)
        end if
        icon=icon+1
        clx=con//','//trim(var)
       else
        clx=trim(clx)//','//trim(var)
       end if
       lclx=len_trim(clx)
       ntnend=trim(clx)
      end if


      end subroutine wrntdcls
