      subroutine kinkk6(ikin,imom,ecm,m,p,x,ndim,dlips)
 
      use inprms
      use kincuts
      use ntnkin
 
      implicit none
 
      integer, parameter :: nepl=7
      integer :: ikin,imom,ndim
      real(dp) :: ecm,m(nepl),p(0:3,nepl),x(ndim),dlips,v(3),g
      real(dp), dimension(0:3) :: q1,q2,q3
      real(dp) :: sqsl1,sqsl2,sqsl3
      real(dp) :: sqsu1,sqsu2,sqsu3
      real(dp) :: sqs1,sqs2,sqs3
      real(dp) :: ds1,ds2,ds3
      real(dp) :: s1,s2,s3
      real(dp) :: dl1,dl2,dl3
 
      if (ikin <= nt133) then                                                   
       sqsl1=m(3)+m(6)                                                          
       sqsl2=m(4)+m(5)                                                          
       sqsl3=sqsl2+m(7)                                                         
       if (imom /= 1) then                                                      
        q1=p(:,3)+p(:,6)                                                        
        q2=p(:,4)+p(:,5)                                                        
        q3=q2+p(:,7)                                                            
       end if                                                                   
       if (ikin == 260) then                                                    
       sqsu1=ecm-sqsl3                                                          
       call mapbkk(imom,x(1),q1,mpi0,zero,sqsl1,sqsu1,s1,sqs1,ds1)              
       sqsu3=ecm-sqs1                                                           
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)              
       sqsu2=sqs3-m(7)                                                          
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)                 
       end if                                                                   
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(6:7),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt134) then
       sqsl1=m(4)+m(5)
       sqsl2=m(6)+m(7)
       sqsl3=sqsl1+sqsl2
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,6)+p(:,7)
        q3=q1+q2
       end if
       if (ikin == 261) then
       sqsu3=ecm-m(3)
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 262) then
       sqsu3=ecm-m(3)
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(6),m(7),x(6:7),p(:,6),p(:,7),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(8:9),q1,q2,dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt135) then
       sqsl1=m(3)+m(6)
       sqsl2=sqsl1+m(4)
       sqsl3=sqsl2+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=q1+p(:,4)
        q3=q2+p(:,5)
       end if
       if (ikin == 263) then
       sqsu3=ecm-m(7)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 264) then
       sqsu3=ecm-m(7)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 265) then
       sqsu3=ecm-m(7)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,sqs1,m(4),x(6:7),q1,p(:,4),dl2)
       call kinff(imom,sqs3,sqs2,m(5),x(8:9),q2,p(:,5),dl3)
       call kinff(imom,ecm,m(7),sqs3,x(10:11),p(:,7),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,4))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt137) then
       sqsl1=m(3)+m(6)
       sqsl2=sqsl1+m(4)
       sqsl3=sqsl2+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=q1+p(:,4)
        q3=q2+p(:,5)
       end if
       if (ikin == 266) then
       sqsu3=ecm-m(7)
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,sqs1,m(4),x(6:7),q1,p(:,4),dl2)
       call kinff(imom,sqs3,sqs2,m(5),x(8:9),q2,p(:,5),dl3)
       call kinff(imom,ecm,m(7),sqs3,x(10:11),p(:,7),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,4))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt138) then
       sqsl1=m(4)+m(5)
       sqsl2=m(3)+m(7)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,3)+p(:,7)
        q3=q2+p(:,6)
       end if
       if (ikin == 267) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 268) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 269) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 270) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),m(7),x(6:7),p(:,3),p(:,7),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt139) then
       sqsl1=m(4)+m(5)
       sqsl2=m(6)+m(7)
       sqsl3=m(3)+sqsl2
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,6)+p(:,7)
        q3=p(:,3)+q2
       end if
       if (ikin == 271) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 272) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 273) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 274) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(6),m(7),x(6:7),p(:,6),p(:,7),dl2)
       call kinff(imom,sqs3,m(3),sqs2,x(8:9),p(:,3),q2,dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt140) then
       sqsl1=m(4)+m(5)
       sqsl2=m(3)+m(6)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,3)+p(:,6)
        q3=q2+p(:,7)
       end if
       if (ikin == 275) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 276) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 277) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 278) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 279) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi0,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),m(6),x(6:7),p(:,3),p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt141) then
       sqsl1=m(4)+m(5)
       sqsl2=m(3)+m(6)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,3)+p(:,6)
        q3=q2+p(:,7)
       end if
       if (ikin == 280) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi0,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),m(6),x(6:7),p(:,3),p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt142) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(7)
       sqsl3=sqsl2+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,7)
        q3=q2+p(:,5)
       end if
       if (ikin == 281) then
       sqsu3=ecm-sqsl1
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 282) then
       sqsu3=ecm-sqsl1
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(7),x(6:7),p(:,4),p(:,7),dl2)
       call kinff(imom,sqs3,sqs2,m(5),x(8:9),q2,p(:,5),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt143) then
       sqsl1=m(3)+m(6)
       sqsl2=m(5)+m(7)
       sqsl3=m(4)+sqsl2
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,5)+p(:,7)
        q3=p(:,4)+q2
       end if
       if (ikin == 283) then
       sqsu3=ecm-sqsl1
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 284) then
       sqsu3=ecm-sqsl1
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(5),m(7),x(6:7),p(:,5),p(:,7),dl2)
       call kinff(imom,sqs3,m(4),sqs2,x(8:9),p(:,4),q2,dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt144) then
       sqsl1=m(5)+m(6)
       sqsl2=m(3)+m(4)
       sqsl3=sqsl2+sqsl1
       if (imom /= 1) then
        q1=p(:,5)+p(:,6)
        q2=p(:,3)+p(:,4)
        q3=q2+q1
       end if
       if (ikin == 285) then
       sqsu3=ecm-m(7)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs3-sqs2
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 286) then
       sqsu3=ecm-m(7)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs3-sqs2
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 287) then
       sqsu3=ecm-m(7)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(3),m(4),x(6:7),p(:,3),p(:,4),dl2)
       call kinff(imom,sqs3,sqs2,sqs1,x(8:9),q2,q1,dl3)
       call kinff(imom,ecm,m(7),sqs3,x(10:11),p(:,7),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt146) then
       sqsl1=m(5)+m(6)
       sqsl2=m(3)+m(4)
       sqsl3=sqsl2+sqsl1
       if (imom /= 1) then
        q1=p(:,5)+p(:,6)
        q2=p(:,3)+p(:,4)
        q3=q2+q1
       end if
       if (ikin == 288) then
       sqsu3=ecm-m(7)
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs3-sqs2
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(3),m(4),x(6:7),p(:,3),p(:,4),dl2)
       call kinff(imom,sqs3,sqs2,sqs1,x(8:9),q2,q1,dl3)
       call kinff(imom,ecm,m(7),sqs3,x(10:11),p(:,7),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt147) then
       sqsl1=m(3)+m(4)
       sqsl2=m(5)+m(7)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,5)+p(:,7)
        q3=q2+p(:,6)
       end if
       if (ikin == 289) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 290) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 291) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 292) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(4),x(4:5),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(5),m(7),x(6:7),p(:,5),p(:,7),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt148) then
       sqsl1=m(3)+m(4)
       sqsl2=m(6)+m(7)
       sqsl3=m(5)+sqsl2
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,6)+p(:,7)
        q3=p(:,5)+q2
       end if
       if (ikin == 293) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 294) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 295) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 296) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(4),x(4:5),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(6),m(7),x(6:7),p(:,6),p(:,7),dl2)
       call kinff(imom,sqs3,m(5),sqs2,x(8:9),p(:,5),q2,dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt149) then
       sqsl1=m(3)+m(4)
       sqsl2=m(5)+m(6)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,5)+p(:,6)
        q3=q2+p(:,7)
       end if
       if (ikin == 297) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 298) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 299) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 300) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 301) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi0,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       call kinff(imom,sqs1,m(3),m(4),x(4:5),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(5),m(6),x(6:7),p(:,5),p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt150) then
       sqsl1=m(3)+m(7)
       sqsl2=m(5)+m(6)
       sqsl3=m(4)+sqsl2
       if (imom /= 1) then
        q1=p(:,3)+p(:,7)
        q2=p(:,5)+p(:,6)
        q3=p(:,4)+q2
       end if
       if (ikin == 302) then
       sqsu3=ecm-sqsl1
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 303) then
       sqsu3=ecm-sqsl1
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(7),x(4:5),p(:,3),p(:,7),dl1)
       call kinff(imom,sqs2,m(5),m(6),x(6:7),p(:,5),p(:,6),dl2)
       call kinff(imom,sqs3,m(4),sqs2,x(8:9),p(:,4),q2,dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt151) then
       sqsl1=m(4)+m(7)
       sqsl2=m(5)+m(6)
       sqsl3=sqsl1+sqsl2
       if (imom /= 1) then
        q1=p(:,4)+p(:,7)
        q2=p(:,5)+p(:,6)
        q3=q1+q2
       end if
       if (ikin == 304) then
       sqsu3=ecm-m(3)
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-sqsl1
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 305) then
       sqsu3=ecm-m(3)
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(4),m(7),x(4:5),p(:,4),p(:,7),dl1)
       call kinff(imom,sqs2,m(5),m(6),x(6:7),p(:,5),p(:,6),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(8:9),q1,q2,dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt152) then
       sqsl1=m(3)+m(4)
       sqsl2=m(5)+m(6)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=p(:,5)+p(:,6)
        q3=q2+p(:,7)
       end if
       if (ikin == 306) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi0,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(4),x(4:5),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,m(5),m(6),x(6:7),p(:,5),p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt153) then
       sqsl1=m(3)+m(7)
       sqsl2=sqsl1+m(6)
       sqsl3=m(4)+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,7)
        q2=q1+p(:,6)
        q3=p(:,4)+p(:,5)
       end if
       if (ikin == 307) then
       sqsu2=ecm-sqsl3
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(3),m(7),x(4:5),p(:,3),p(:,7),dl1)
       call kinff(imom,sqs2,sqs1,m(6),x(6:7),q1,p(:,6),dl2)
       call kinff(imom,sqs3,m(4),m(5),x(8:9),p(:,4),p(:,5),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt154) then
       sqsl1=m(6)+m(7)
       sqsl2=m(3)+sqsl1
       sqsl3=m(4)+m(5)
       if (imom /= 1) then
        q1=p(:,6)+p(:,7)
        q2=p(:,3)+q1
        q3=p(:,4)+p(:,5)
       end if
       if (ikin == 308) then
       sqsu2=ecm-sqsl3
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(6),m(7),x(4:5),p(:,6),p(:,7),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(6:7),p(:,3),q1,dl2)
       call kinff(imom,sqs3,m(4),m(5),x(8:9),p(:,4),p(:,5),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      end if
 
      end
