      subroutine logo(u)

      use inprms
      use drivekk
      use partcls
      use couplsmkk
      use topan
      use clrinf
      use vmesoncrit

      implicit none

      integer :: u,i,j
      character(20) :: ind
      character(80) :: cline

      write(u,4000)
c      write(u,2000)
      write(u,5000)
      write(u,2000)
      if (ihad == 1) then
       write(u,'(a$)') '#                 p p~  ->  '
      else if (ihad == 2) then
       write(u,'(a$)') '#                  p p  ->  '
      else
       write(u,'(a$)') '#                       '
      end if
      do i=1,nisp
       write(u,'(a$)') trim(expc(i))//' '
      end do
      write(u,'(a$)') ' ->  '
      do i=nisp+1,nepl-1
       write(u,'(a$)') trim(expc(i))//' '
      end do
      write(u,'(a)') trim(expc(nepl))

      write(u,2000)
      write(u,5010) trim(adjustl(prvrsn))//', by'
      write(u,2000)
      write(u,5020)
      write(u,5030)
      write(u,5040)
      write(u,5050)
      write(u,2000)
      write(ind,'(i10)') ndgs
      write(u,'(a)')'# '//trim(adjustl(ind))//' Feynman diagrams'//
     & ' in the unitary gauge were generated'
      write(ind,'(i10)') iclrx
      if (iclrx == 1) then
       write(u,'(a)')'# '//trim(adjustl(ind))//' colour'//
     & ' factor is used'
      else
       write(u,'(a)')'# '//trim(adjustl(ind))//' different colour'//
     & ' factors are used'
      end if
c      write(u,2000)
      write(u,4000)

 2000 format('#')
 2005 format(' ')
 4000 format('#=======================================================',
     &       '======================#')
 5000 format('# The process:')
 5010 format('# computed with ',a)
 5020 format('#                            Karol Kolodziej')
 5030 format('#                         University of Silesia')
 5040 format('#                            Katowice, Poland')
 5050 format('#                   e-mail: karol.kolodziej@us.edu.pl')

      if (igauge > 0) then
       write(u,'(a,i2)')'# THIS IS TEST OF THE U(1) GAUGE INVARIANCE '
     & //'WITH PHOTON #',igauge
       write(u,4000)
      end if

      if (ipiff == 1) then
       write(u,'(a,i2)')'# THIS IS CALCULATION OF THE PION FORM FACTOR'
       write(u,4000)
      end if

c      write(u,'(a)') '# The following HLS rules are included in '
c     &   //'addition to the Standard Model:'



      if (iprint == 1) then
       open(unit=19,file='vrtxinf.dat',status='old',action='read')
       do 
        read(19,'(a80)',end=7000) cline
        write(u,'(a)') trim(cline)
       end do
 7000  close(19)
       write(u,'(a)') '# where:'
       write(u,'(a,2(e13.6),a,i4)') 
     &                     '#    app=(',app,'),  runcoupl option:',iapp
       write(u,'(a,2(e13.6),a,i4)') 
     &                     '#    akk=(',akk,'),  runcoupl option:',iakk
       write(u,'(a,2(e13.6),a,i4)') 
     &                 '#  ak0k0=(',ak0k0,'),  runcoupl option:',iak0k0
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   r0pp=(',r0pp,'),  runcoupl option:',ir0pp
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   r0kk=(',r0kk,'),  runcoupl option:',ir0kk
       write(u,'(a,2(e13.6),a,i4)') 
     &               '# r0k0k0=(',r0k0k0,'),  runcoupl option:',ir0k0k0
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   r1pp=(',r1pp,'),  runcoupl option:',ir1pp
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   r2pp=(',r2pp,'),  runcoupl option:',ir2pp
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#    opp=(',opp,'),  runcoupl option:',iopp
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#    okk=(',okk,'),  runcoupl option:',iokk
       write(u,'(a,2(e13.6),a,i4)') 
     &                 '#  ok0k0=(',ok0k0,'),  runcoupl option:',iok0k0
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   phpp=(',phpp,'),  runcoupl option:',iphpp
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   phkk=(',phkk,'),  runcoupl option:',iphkk
       write(u,'(a,2(e13.6),a,i4)') 
     &               '# phk0k0=(',phk0k0,'),  runcoupl option:',iphk0k0
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#    paa=(',paa,'),  runcoupl option:',ipaa
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   par0=(',par0,'),  runcoupl option:',ipar0
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   parp=(',parp,'),  runcoupl option:',iparp
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   parm=(',parm,'),  runcoupl option:',iparm
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#    pao=(',pao,'),  runcoupl option:',ipao
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   por0=(',por0,'),  runcoupl option:',ipor0
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   porp=(',porp,'),  runcoupl option:',iporp
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   porm=(',porm,'),  runcoupl option:',iporm
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   aapp=(',aapp,'),  runcoupl option:',iaapp
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   arpp=(',arpp,'),  runcoupl option:',iarpp
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   rrpp=(',rrpp,'),  runcoupl option:',irrpp
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   appp=(',appp,'),  runcoupl option:',iappp
       write(u,'(a,2(e13.6),a,i4)') 
     &                   '#   oppp=(',oppp,'),  runcoupl option:',ioppp
       if (iarho == 1) then
        write(u,4000)
        write(u,'(a,f9.4,a,f9.4,a)') 
     &   '# gamma-rho0 mixing included, mrho =',mrho*1.d3,' MeV, '//
     &   'gmrh =',gmrh*1.d3,' MeV, with'
        if (igmrh == 1) then
         write(u,'(a,i2,a)') '# running width of rho0, igmrh =',igmrh,
     &    ', see runwidth.f for details'
        else
         write(u,'(a)') '# fixed width of rho0'
        end if
        if (imrho == 0) then
         write(u,'(a,2(e13.6),a,i2)') '# arho=(',arho,'), imrho=',imrho
        else
         write(u,'(a,2(e13.6),a,e10.3,a,f7.2,a)') 
     &    '# arho=(',arho,'), wmrho=',wmrho,', dmrho=',dmrho,' deg'
         write(u,'(a,i2,a)') '# weight option imrho=',imrho,
     &                       ', see weightfactor.f for details'
        end if
       end if
       if (iaome == 1) then
        write(u,4000)
        write(u,'(a,f9.4,a,f9.4,a)') 
     &   '# gamma-omega mixing included, mome =',mome*1.d3,' MeV, '//
     &   'gmom =',gmom*1.d3,' MeV, with'
        if (igmom == 1) then
         write(u,'(a,i2,a)') '# running width of omega, igmom =',igmom,
     &    ', see runwidth.f for details'
        else
         write(u,'(a)') '# fixed width of omega'
        end if
        if (imome == 0) then
         write(u,'(a,2(e13.6),a,i2)') '# aome=(',aome,'), imome=',imome
        else
         write(u,'(a,2(e13.6),a,e10.3,a,f7.2,a)')
     &    '# aome=(',aome,'), wmome=',wmome,', dmome=',dmome,' deg'
         write(u,'(a,i2,a)') '# weight option imome=',imome,
     &                       ', see weightfactor.f for details'
        end if
       end if
       if (iaphi == 1) then
        write(u,4000)
        write(u,'(a,f9.4,a,f9.4,a)') 
     &   '# gamma-phi mixing included, mome =',mphi*1.d3,' MeV, '//
     &   'gmph =',gmph*1.d3,' MeV, with'
        if (igmph == 1) then
         write(u,'(a,i2,a)') '# running width of phi, igmph =',igmph,
     &    ', see runwidth.f for details'
        else
         write(u,'(a)') '# fixed width of phi'
        end if
        if (imphi == 0) then
         write(u,'(a,2(e13.6),a,i2)') '# aphi=(',aphi,'), imphi=',imphi
        else
         write(u,'(a,2(e13.6),a,e10.3,a,f7.2,a)')
     &    '# aphi=(',aphi,'), wmphi=',wmphi,', dmphi=',dmphi,' deg'
         write(u,'(a,i2,a)') '# weight option imphi=',imphi,
     &                       ', see weightfactor.f for details'
        end if
       end if
       if (iarho1 == 1) then
        write(u,4000)
        write(u,'(a,f9.4,a,f9.4,a)') 
     &   '# gamma-rho1 mixing included, mrh1 =',mrh1*1.d3,' MeV, '//
     &   'gmr1 =',gmr1*1.d3,' MeV, with'
        if (igmr1 == 1) then
         write(u,'(a,i2,a)') '# running width of rho1, igmr1 =',igmr1,
     &    ', see runwidth.f for details'
        else
         write(u,'(a)') '# fixed width of rho1'
        end if
        if (imrh1 == 0) then
         write(u,'(a,2(e13.6),a,i2)') '# arh1=(',arh1,'), imrh1=',imrh1
        else
         write(u,'(a,2(e13.6),a,e10.3,a,f7.2,a)') 
     &    '# arh1=(',arh1,'), wmrh1=',wmrh1,', dmrho=',dmrh1,' deg'
         write(u,'(a,i2,a)') '# weight option imrh1=',imrh1,
     &                       ', see weightfactor.f for details'
        end if
       end if
       if (iarho2 == 1) then
        write(u,4000)
        write(u,'(a,f9.4,a,f9.4,a)') 
     &   '# gamma-rho2 mixing included, mrh2 =',mrh2*1.d3,' MeV, '//
     &   'gmr2 =',gmr2*1.d3,' MeV, with'
        if (igmr2 == 1) then
         write(u,'(a,i2,a)') '# running width of rho2, igmr2 =',igmr2,
     &    ', see runwidth.f for details'
        else
         write(u,'(a)') '# fixed width of rho2'
        end if
        if (imrh2 == 0) then
         write(u,'(a,2(e13.6),a,i2)') '# arh2=(',arh2,'), imrh2=',imrh2
        else
         write(u,'(a,2(e13.6),a,e10.3,a,f7.2,a)') 
     &    '# arh2=(',arh2,'), wmrh2=',wmrh2,', dmrho=',dmrh2,' deg'
         write(u,'(a,i2,a)') '# weight option imrh2=',imrh2,
     &                       ', see weightfactor.f for details'
        end if
       end if
      end if

      write(u,4000)
      write(u,'(a)') '# External particle masses:'
      do j=1,nepl
       write(u,2102) trim(expc(j)),m(j)
 2102  format('#  m(',a,') =',e15.8)
      end do
      write(u,4000)

      if (ihad > 0) then
       if (ipdf == 1) then
        write(u,'(a,$)') '# '//
     &              prefix(index(prefix,'mstw2008'):len_trim(prefix))
        write(u,'(a,i2,a)') 
     &     ' partons are used, iset =',iset,','
       else if (ipdf == 2) then
        if (iset == 1) then
         write(u,'(a)') 
     &     '# CTEQ6M partons are used (Standard MSbar scheme)'
        else if (iset == 2) then
         write(u,'(a)') 
     &     '# CTEQ6D partons are used (Standard DIS scheme)'
        else if (iset == 3) then
         write(u,'(a)') '# CTEQ6L partons are used '//
     &      '(Leading Order, Alpha_s(Mz)=0.118)'
        else if (iset == 4) then
         write(u,'(a)') '# CTEQ6L1 partons are used '//
     &      '(Leading Order, Alpha_s(Mz)=0.130)'
        end if
       end if
       write(u,'(a$)') '# at the scale Q ='
       if (iscl == 1) then
        write(u,'(f4.1,a)') sclf,'*sqrt(s'')'
       else if (iscl == 2) then
        write(u,'(e12.5)') sclf
       else if (iscl == 3) then
        write(u,'(f4.1,a)') sclf,'*sqrt(mt^2+sum of ptj^2)'
       end if
       write(u,'(a)')'#'
      end if
      if (ischeme == 1) then
        write(u,2095)
 2095   format('# Complex mass scheme')
        write(u,5029) csw2
 5029   format('# with sw2 = (',f18.15,',',f18.15,')')
      else
        write(u,2098) sw2
 2098   format('# Fixed width scheme with real sw2, sw2 =', f18.15)
      end if

      if (iprint == 2) then
       write(u,5035) ialphw
 5035  format('# alpha_W kept real, 1/alpha_W = ',f19.15)
      end if
      write(u,2000)

      write(u,'(a$)')'# EW couplings parametrized in terms of '
      if (ialpha == 0) then
       write(u,'(a,f14.8)')'alpha in the Thomson limit,'
       write(u,'(a,f14.8)')'# 1/alpha_0 =',ialph0
      else if (ialpha == 1) then
       write(u,'(a,f14.8)')'alpha_W, 1/alpha_W =',ialphw
      else if (ialpha == 2) then
       write(u,'(a,f14.8)')'alphao, 1/alphao =',ialpho
      end if
      write(u,2000)

      if (iprint == 2) then
       write(u,2120)
 2120  format('# Gauge boson masses and widths:',
     &           ' W, Gm_W, Z, Gm_Z')
       write(u,1002) mw,gamw,mz,gamz
 1002  format('# ',4(f12.5))
c      write(u,2121) gamwsm0
c 2121 format('# W boson width to the lowest order of SM:',f22.16)
       write(u,2000)

       write(u,2122)
 2122  format('# Higgs boson mass and width: H, Gm_H')
       write(u,2002) mh,gamh
 2002  format('# ',2(e15.5))

       write(u,2000)

       write(u,1003) ialph0,alphas,gmu
 1003  format('# 1/alpha0 = ',f11.7,'   alphas(m_Z) = ',f10.7,
     &       '   G_mu = ',e13.6)

       write(u,2000)

       if (inwtb == 1) then
        if (iwtb == 1) then
         write(u,'(a)')'# CP even anomalous Wtb coupling, see K. Kolo'
     &              //'dziej PLB 584(2004)89,' 
         write(u,'(a)')'# hep-ph/0312168, Eqs. (4),(5) and (6) with'
         write(u,'(a,f7.4,a,f7.4,a,f7.4,a,f7.4,a,f7.4)') '# f1+ =',f1p,
     &          ' f1- =',f1m,' f2+ =',f2p,' f2- =',f2m
         write(u,'(a,f7.4,a,f7.4,a,f7.4,a,f7.4,a,f7.4)') '# f1b+ =',f1p,
     &         ' f1b- =',f1m,' f2b+ =',f2m,' f2b- =',f2p
         write(u,2000)
        else if (iwtb == 2) then
         write(u,'(a)')'# CP odd anomalous Wtb coupling, see K. Kolo'
     &              //'dziej PLB 584(2004)89,' 
         write(u,'(a)')'# hep-ph/0312168, Eqs. (4) and (5) with'
         write(u,'(a,f7.4,a,f7.4,a,f7.4,a,f7.4,a,f7.4)') '# f1+  =',f1p,
     &         ' f1-  =',f1m,' f2+  =',f2p,' f2-  =',f2m
         write(u,'(a,f7.4,a,f7.4,a,f7.4,a,f7.4,a,f7.4)') '# f1b+ =',
     &      f1bp,' f1b- =',f1bm,' f2b+ =',f2bp,' f2b- =',f2bm
         write(u,2000)
        end if
       else
        if (iwtb == 1 .or. iwtb == 2) then
         write(u,'(a)')'# CODE MUST BE GENERATED WITH iwtb=1 TO INCLUDE'
     &              //' ANOMALOUS Wtb COUPLING!'
         write(u,2000)
        end if
       end if

       if (iwtb == 2) then
        write(u,'(a)')'# t-quark mass, t width and anti-t width:'
        write(u,'(a,f10.2,f12.5,f13.5)') '#',mt,gamt,gmtb
       else
        write(u,2110)
 2110   format('# t-quark mass and width:')
        write(u,1020) mt,gamt
 1020   format('#',f10.2,f12.5)
       end if

       write(u,2000)

       if (ihtt == 1) then
        write(u,'(a)') '# Anomalous Htt coupling included, see J.A. '//
     &  'Aguilar-Saavedra, NPB821 (2009) 215,'
        write(u,'(a,f7.4,a,f7.4)') '# httv =',httv,' htta =',htta
        write(u,2000)
       end if
      end if

      if (convc/0.389d-3 > 1.d18) then
       write(u,'(a,e16.9)') '# All cross sections in attobarns (ab),'
     &                    //' convc =',convc
      else if (convc/0.389d-3 > 1.d15) then
       write(u,'(a,e16.9)') '# All cross sections in femtobarns (fb),'
     &                    //' convc =',convc
      else if (convc/0.389d-3 > 1.d12) then
       write(u,'(a,e16.9)') '# All cross sections in pikobarns (pb), '//
     &                      'convc =',convc
      else if (convc/0.389d-3 > 1.d9) then
       write(u,'(a,e16.9)') '# All cross sections in nanobarns (nb), '//
     &                      'convc =',convc
      else if (convc/0.389d-3 > 1.d6) then
       write(u,'(a,e16.9)') '# All cross sections in microobarns (mub),'
     &                    //' convc =',convc
      else if (convc/0.389d-3 > 1.d3) then
       write(u,'(a,e16.9)') '# All cross sections in milibarns (mb), '//
     &                      'convc =',convc
      end if

      if (nmcs > 0) then
       write(u,'(a)') '# Monte Carlo summing over helicities of '//
     &                'external prticles'
      end if
      write(u,'(a,i4,a)') '# Propagators of subsystems with up to',
     &                     mxmap,' particles are mapped.'
      if (ickm == 1) then
       write(u,'(a)') '# Cabibbo-Kobayashi-Maskawa mixing included'
      end if
      write(u,2000)

      end
