      subroutine kinkk5(ikin,imom,ecm,m,p,x,ndim,dlips)
 
      use inprms
      use kincuts
      use ntnkin
 
      implicit none
 
      integer, parameter :: nepl=7
      integer :: ikin,imom,ndim
      real(dp) :: ecm,m(nepl),p(0:3,nepl),x(ndim),dlips,v(3),g
      real(dp), dimension(0:3) :: q1,q2,q3
      real(dp) :: sqsl1,sqsl2,sqsl3
      real(dp) :: sqsu1,sqsu2,sqsu3
      real(dp) :: sqs1,sqs2,sqs3
      real(dp) :: ds1,ds2,ds3
      real(dp) :: s1,s2,s3
      real(dp) :: dl1,dl2,dl3
 
      if (ikin <= nt105) then                                                   
       sqsl1=m(5)+m(6)                                                          
       sqsl2=sqsl1+m(7)                                                         
       sqsl3=m(4)+sqsl2                                                         
       if (imom /= 1) then                                                      
        q1=p(:,5)+p(:,6)                                                        
        q2=q1+p(:,7)                                                            
        q3=p(:,4)+q2                                                            
       end if                                                                   
       if (ikin == 207) then                                                    
       sqsu3=ecm-m(3)                                                           
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)               
       sqsu2=sqs3-m(4)                                                          
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)                 
       sqsu1=sqs2-m(7)                                                          
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)                                          
       if (imom == 1) then                                                      
        s1=ds1*x(1)+sqsl1*sqsl1                                                 
       else                                                                     
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)                  
       end if                                                                   
       sqs1=sqrt(s1)                                                            
       end if                                                                   
       if (ikin == 208) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       if (ikin == 209) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,sqs1,m(7),x(6:7),q1,p(:,7),dl2)
       call kinff(imom,sqs3,m(4),sqs2,x(8:9),p(:,4),q2,dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt106) then
       sqsl1=m(4)+m(7)
       sqsl2=m(5)+m(6)
       sqsl3=sqsl1+sqsl2
       if (imom /= 1) then
        q1=p(:,4)+p(:,7)
        q2=p(:,5)+p(:,6)
        q3=q1+q2
       end if
       if (ikin == 210) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 211) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 212) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 213) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(4),m(7),x(4:5),p(:,4),p(:,7),dl1)
       call kinff(imom,sqs2,m(5),m(6),x(6:7),p(:,5),p(:,6),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(8:9),q1,q2,dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt107) then
       sqsl1=m(5)+m(6)
       sqsl2=m(4)+sqsl1
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,5)+p(:,6)
        q2=p(:,4)+q1
        q3=q2+p(:,7)
       end if
       if (ikin == 214) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 215) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),sqs1,x(6:7),p(:,4),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt109) then
       sqsl1=m(5)+m(6)
       sqsl2=m(4)+sqsl1
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,5)+p(:,6)
        q2=p(:,4)+q1
        q3=q2+p(:,7)
       end if
       if (ikin == 216) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 217) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 218) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 219) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 220) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),sqs1,x(6:7),p(:,4),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt111) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=sqsl1+sqsl2
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=q1+q2
       end if
       if (ikin == 221) then
       sqsu3=ecm-m(7)
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(6:7),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(8:9),q1,q2,dl3)
       call kinff(imom,ecm,m(7),sqs3,x(10:11),p(:,7),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt112) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=q2+p(:,7)
       end if
       if (ikin == 222) then
       sqsu3=ecm-sqsl1
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=ecm-sqs3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(6:7),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt113) then
       sqsl1=m(3)+m(6)
       sqsl2=sqsl1+m(7)
       sqsl3=m(4)+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=q1+p(:,7)
        q3=p(:,4)+p(:,5)
       end if
       if (ikin == 223) then
       sqsu3=ecm-sqsl2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs3
       call mapbkk(imom,x(2),q2,mpi0,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,sqs1,m(7),x(6:7),q1,p(:,7),dl2)
       call kinff(imom,sqs3,m(4),m(5),x(8:9),p(:,4),p(:,5),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt114) then
       sqsl1=m(3)+m(6)
       sqsl2=sqsl1+m(7)
       sqsl3=m(4)+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=q1+p(:,7)
        q3=p(:,4)+p(:,5)
       end if
       if (ikin == 224) then
       sqsu3=ecm-sqsl2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs3
       call mapbkk(imom,x(2),q2,mpi0,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,sqs1,m(7),x(6:7),q1,p(:,7),dl2)
       call kinff(imom,sqs3,m(4),m(5),x(8:9),p(:,4),p(:,5),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt115) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=q2+p(:,7)
       end if
       if (ikin == 225) then
       sqsu3=ecm-sqsl1
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(6:7),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt116) then
       sqsl1=m(3)+m(7)
       sqsl2=m(4)+m(5)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,3)+p(:,7)
        q2=p(:,4)+p(:,5)
        q3=q2+p(:,6)
       end if
       if (ikin == 226) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 227) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 228) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(7),x(4:5),p(:,3),p(:,7),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(6:7),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt118) then
       sqsl1=m(4)+m(7)
       sqsl2=sqsl1+m(5)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,7)
        q2=q1+p(:,5)
        q3=q2+p(:,6)
       end if
       if (ikin == 229) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 230) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 231) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(4),m(7),x(4:5),p(:,4),p(:,7),dl1)
       call kinff(imom,sqs2,sqs1,m(5),x(6:7),q1,p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt119) then
       sqsl1=m(5)+m(7)
       sqsl2=m(4)+sqsl1
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,5)+p(:,7)
        q2=p(:,4)+q1
        q3=q2+p(:,6)
       end if
       if (ikin == 232) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 233) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 234) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(7),x(4:5),p(:,5),p(:,7),dl1)
       call kinff(imom,sqs2,m(4),sqs1,x(6:7),p(:,4),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt120) then
       sqsl1=m(4)+m(5)
       sqsl2=sqsl1+m(7)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=q1+p(:,7)
        q3=q2+p(:,6)
       end if
       if (ikin == 235) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       if (ikin == 236) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       if (ikin == 237) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,sqs1,m(7),x(6:7),q1,p(:,7),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt121) then
       sqsl1=m(4)+m(5)
       sqsl2=m(6)+m(7)
       sqsl3=sqsl1+sqsl2
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,6)+p(:,7)
        q3=q1+q2
       end if
       if (ikin == 238) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 239) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 240) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 241) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(6),m(7),x(6:7),p(:,6),p(:,7),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(8:9),q1,q2,dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt122) then
       sqsl1=m(4)+m(5)
       sqsl2=sqsl1+m(6)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=q1+p(:,6)
        q3=q2+p(:,7)
       end if
       if (ikin == 242) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 243) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,sqs1,m(6),x(6:7),q1,p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt124) then
       sqsl1=m(4)+m(5)
       sqsl2=sqsl1+m(6)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=q1+p(:,6)
        q3=q2+p(:,7)
       end if
       if (ikin == 244) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 245) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 246) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 247) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 248) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,sqs1,m(6),x(6:7),q1,p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt126) then
       sqsl1=m(4)+m(5)
       sqsl2=m(3)+sqsl1
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,3)+q1
        q3=q2+p(:,6)
       end if
       if (ikin == 249) then
       sqsu3=ecm-m(7)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(3)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 250) then
       sqsu3=ecm-m(7)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(3)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 251) then
       sqsu3=ecm-m(7)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(6:7),p(:,3),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,m(7),sqs3,x(10:11),p(:,7),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt128) then
       sqsl1=m(4)+m(5)
       sqsl2=m(3)+sqsl1
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,3)+q1
        q3=q2+p(:,6)
       end if
       if (ikin == 252) then
       sqsu3=ecm-m(7)
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(3)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(6:7),p(:,3),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,m(7),sqs3,x(10:11),p(:,7),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt131) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=q2+p(:,7)
       end if
       if (ikin == 253) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 254) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 255) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 256) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 257) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi0,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(6:7),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt132) then
       sqsl1=m(3)+m(7)
       sqsl2=m(4)+m(5)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,3)+p(:,7)
        q2=p(:,4)+p(:,5)
        q3=q2+p(:,6)
       end if
       if (ikin == 258) then
       sqsu3=ecm-sqsl1
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 259) then
       sqsu3=ecm-sqsl1
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(7),x(4:5),p(:,3),p(:,7),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(6:7),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      end if
 
      end
